diff -uNr nagios-plugins-1.4.11/plugins/check_ups.c nagios-plugins-1.4.12/plugins/check_ups.c
--- nagios-plugins-1.4.11/plugins/check_ups.c	2007-10-25 22:43:04.000000000 +0200
+++ nagios-plugins-1.4.12/plugins/check_ups.c	2008-05-07 12:02:42.000000000 +0200
@@ -1,45 +1,43 @@
-/******************************************************************************
-*
+/*****************************************************************************
+* 
 * Nagios check_ups plugin
-*
+* 
 * License: GPL
 * Copyright (c) 2000 Tom Shields
 *               2004 Alain Richard <alain.richard@equation.fr>
 *               2004 Arnaud Quette <arnaud.quette@mgeups.com>
-* Copyright (c) 2002-2006 nagios-plugins team
-*
-* Last Modified: $Date: 2007-10-25 21:43:04 +0100 (Thu, 25 Oct 2007) $
-*
+* Copyright (c) 2002-2007 Nagios Plugins Development Team
+* 
+* Last Modified: $Date: 2008-05-07 11:02:42 +0100 (Wed, 07 May 2008) $
+* 
 * Description:
-*
+* 
 * This file contains Network UPS Tools plugin for Nagios
-*
-*  This plugin tests the UPS service on the specified host.Network UPS Tools
-*  from www.networkupstools.org must be running for thisplugin to work.
-*
-* License Information:
-*
-* This program is free software; you can redistribute it and/or modify
+* 
+* This plugin tests the UPS service on the specified host.Network UPS Tools
+* from www.networkupstools.org must be running for thisplugin to work.
+* 
+* 
+* This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
-* the Free Software Foundation; either version 2 of the License, or
+* the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
-*
+* 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
-*
+* 
 * You should have received a copy of the GNU General Public License
-* along with this program; if not, write to the Free Software
-* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-*
-*  $Id: check_ups.c 1810 2007-10-25 20:43:04Z tonvoon $
-*
-******************************************************************************/
+* along with this program.  If not, see <http://www.gnu.org/licenses/>.
+* 
+* $Id: check_ups.c 1991 2008-05-07 10:02:42Z dermoth $
+* 
+*****************************************************************************/
 
 const char *progname = "check_ups";
-const char *revision = "$Revision: 1810 $";
-const char *copyright = "2002-2006";
+const char *revision = "$Revision: 1991 $";
+const char *copyright = "2000-2007";
 const char *email = "nagiosplug-devel@lists.sourceforge.net";
 
 #include "common.h"
@@ -121,6 +119,9 @@
 	data = strdup ("");
 	message = strdup ("");
 
+	/* Parse extra opts if any */
+	argv=np_extra_opts (&argc, argv, progname);
+
 	if (process_arguments (argc, argv) == ERROR)
 		usage4 (_("Could not parse arguments"));
 
@@ -603,7 +604,7 @@
 	printf ("Copyright (c) 2004 Arnaud Quette <arnaud.quette@mgeups.com>\n");
 	printf (COPYRIGHT, copyright, email);
 
-	printf ("%s\n", _("This plugin tests the UPS service on the specified host.Network UPS Tools "));
+	printf ("%s\n", _("This plugin tests the UPS service on the specified host. Network UPS Tools"));
   printf ("%s\n", _("from www.networkupstools.org must be running for thisplugin to work."));
 
   printf ("\n\n");
@@ -611,6 +612,7 @@
 	print_usage ();
 
 	printf (_(UT_HELP_VRSN));
+	printf (_(UT_EXTRA_OPTS));
 
 	printf (_(UT_HOST_PORT), 'p', myport);
 
@@ -630,22 +632,27 @@
 /*	printf (_(UT_VERBOSE)); */
 
   printf ("\n");
-  printf ("%s\n", _("Notes:"));
-  
 	printf ("%s\n", _("This plugin attempts to determine the status of a UPS (Uninterruptible Power"));
   printf ("%s\n", _("Supply) on a local or remote host. If the UPS is online or calibrating, the"));
   printf ("%s\n", _("plugin will return an OK state. If the battery is on it will return a WARNING"));
   printf ("%s\n", _("state.If the UPS is off or has a low battery the plugin will return a CRITICAL"));
-  printf ("%s\n\n", _("state."));
+  printf ("%s\n", _("state."));
 
-	printf ("%s\n", _("You may also specify a variable to check [such as temperature, utility voltage,"));
-  printf ("%s\n", _("battery load, etc.]  as well as warning and critical thresholds for the value of"));
-  printf ("%s\n", _("that variable.  If the remote host has multiple UPS that are being monitored you"));
-  printf ("%s\n", _("will have to use the [ups] option to specify which UPS to check."));
-
-	printf ("%s\n", _("This plugin requires that the UPSD daemon distributed with Russel Kroll's"));
-  printf ("%s\n", _("Smart UPS Tools be installed on the remote host.  If you do not have the"));
-  printf ("%s\n", _("package installed on your system, you can download it from http://www.networkupstools.org"));
+  printf ("\n");
+  printf ("%s\n", _("Notes:"));
+  printf (" %s\n", _("You may also specify a variable to check (such as temperature, utility voltage,"));
+  printf (" %s\n", _("battery load, etc.)  as well as warning and critical thresholds for the value"));
+  printf (" %s\n", _("of that variable.  If the remote host has multiple UPS that are being monitored"));
+  printf (" %s\n", _("you will have to use the --ups option to specify which UPS to check."));
+  printf ("\n");
+  printf (" %s\n", _("This plugin requires that the UPSD daemon distributed with Russel Kroll's"));
+  printf (" %s\n", _("Smart UPS Tools be installed on the remote host. If you do not have the"));
+  printf (" %s\n", _("package installed on your system, you can download it from"));
+  printf (" %s\n", _("http://www.networkupstools.org"));
+#ifdef NP_EXTRA_OPTS
+  printf ("\n");
+  printf (_(UT_EXTRA_OPTS_NOTES));
+#endif
 
 	printf (_(UT_SUPPORT));
 }
diff -uNr nagios-plugins-1.4.11/plugins/check_users.c nagios-plugins-1.4.12/plugins/check_users.c
--- nagios-plugins-1.4.11/plugins/check_users.c	2007-01-28 22:46:41.000000000 +0100
+++ nagios-plugins-1.4.12/plugins/check_users.c	2008-05-07 12:02:42.000000000 +0200
@@ -1,42 +1,41 @@
-/******************************************************************************
-*
+/*****************************************************************************
+* 
 * Nagios check_users plugin
-*
+* 
 * License: GPL
-* Copyright (c) 2000-2006 nagios-plugins team
-*
-* Last Modified: $Date: 2007-01-28 21:46:41 +0000 (Sun, 28 Jan 2007) $
-*
+* Copyright (c) 2000-2007 Nagios Plugins Development Team
+* 
+* Last Modified: $Date: 2008-05-07 11:02:42 +0100 (Wed, 07 May 2008) $
+* 
 * Description:
-*
+* 
 * This file contains the check_users plugin
-*
-*  This plugin checks the number of users currently logged in on the local
-*  system and generates an error if the number exceeds the thresholds specified.
-*
-* License Information:
-*
-* This program is free software; you can redistribute it and/or modify
+* 
+* This plugin checks the number of users currently logged in on the local
+* system and generates an error if the number exceeds the thresholds
+* specified.
+* 
+* 
+* This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
-* the Free Software Foundation; either version 2 of the License, or
+* the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
-*
+* 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
-*
+* 
 * You should have received a copy of the GNU General Public License
-* along with this program; if not, write to the Free Software
-* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-*
-*  $Id: check_users.c 1590 2007-01-28 21:46:41Z hweiss $
-*
+* along with this program.  If not, see <http://www.gnu.org/licenses/>.
+* 
+* $Id: check_users.c 1991 2008-05-07 10:02:42Z dermoth $
+* 
 *****************************************************************************/
 
 const char *progname = "check_users";
-const char *revision = "$Revision: 1590 $";
-const char *copyright = "2000-2006";
+const char *revision = "$Revision: 1991 $";
+const char *copyright = "2000-2007";
 const char *email = "nagiosplug-devel@lists.sourceforge.net";
 
 #include "common.h"
@@ -66,6 +65,9 @@
 
 	perf = strdup("");
 
+	/* Parse extra opts if any */
+	argv=np_extra_opts (&argc, argv, progname);
+
 	if (process_arguments (argc, argv) == ERROR)
 		usage4 (_("Could not parse arguments"));
 
@@ -214,12 +216,19 @@
 	print_usage ();
 
 	printf (_(UT_HELP_VRSN));
+	printf (_(UT_EXTRA_OPTS));
 
 	printf (" %s\n", "-w, --warning=INTEGER");
   printf ("    %s\n", _("Set WARNING status if more than INTEGER users are logged in"));
   printf (" %s\n", "-c, --critical=INTEGER");
   printf ("    %s\n", _("Set CRITICAL status if more than INTEGER users are logged in"));
 
+#ifdef NP_EXTRA_OPTS
+  printf ("\n");
+  printf ("%s\n", _("Notes:"));
+  printf (_(UT_EXTRA_OPTS_NOTES));
+#endif
+
 	printf (_(UT_SUPPORT));
 }
 
diff -uNr nagios-plugins-1.4.11/plugins/common.h nagios-plugins-1.4.12/plugins/common.h
--- nagios-plugins-1.4.11/plugins/common.h	2007-04-26 00:10:13.000000000 +0200
+++ nagios-plugins-1.4.12/plugins/common.h	2008-03-11 01:10:23.000000000 +0100
@@ -1,47 +1,40 @@
-/******************************************************************************
- *
- * Nagios plugins common include file
- *
- * License: GPL
- * Copyright (c) 1999 Ethan Galstad (nagios@nagios.org)
- *
- * Last Modified: 11-05-1999
- *
- * Description:
- *
- * This file contains common include files and defines used in many of
- * the plugins.
- *
- * License Information:
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
- *
- * $Id: common.h 1700 2007-04-25 22:10:13Z tonvoon $
- *
- *****************************************************************************/
+/*****************************************************************************
+* 
+* Nagios plugins common include file
+* 
+* License: GPL
+* Copyright (c) 1999 Ethan Galstad (nagios@nagios.org)
+* Copyright (c) 2003-2007 Nagios Plugins Development Team
+* 
+* Last Modified: $Date: 2008-03-11 00:10:23 +0000 (Tue, 11 Mar 2008) $
+* 
+* Description:
+* 
+* This file contains common include files and defines used in many of
+* the plugins.
+* 
+* 
+* This program is free software: you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation, either version 3 of the License, or
+* (at your option) any later version.
+* 
+* This program is distributed in the hope that it will be useful,
+* but WITHOUT ANY WARRANTY; without even the implied warranty of
+* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+* GNU General Public License for more details.
+* 
+* You should have received a copy of the GNU General Public License
+* along with this program.  If not, see <http://www.gnu.org/licenses/>.
+* 
+* $Id: common.h 1938 2008-03-11 00:10:23Z tonvoon $
+* 
+*****************************************************************************/
 
 #ifndef _COMMON_H_
 #define _COMMON_H_
 
 #include "config.h"
-/* This needs to be removed for Solaris servers, where 64 bit files, but 32 bit architecture
-   This needs to be done early on because subsequent system includes use _FILE_OFFSET_BITS
-   Cannot remove from config.h because is included by regex.c from lib/ */
-#if __sun__ && !defined(_LP64) && _FILE_OFFSET_BITS == 64
-#undef _FILE_OFFSET_BITS
-#endif
 
 #ifdef HAVE_FEATURES_H
 #include <features.h>
@@ -118,9 +111,6 @@
 /* GNU Libraries */
 #include <getopt.h>
 #include "dirname.h"
-#include "vasprintf.h"
-#include "snprintf.h"
-#include "vsnprintf.h"
 
 #ifdef HAVE_LOCALE_H
 #include <locale.h>
@@ -186,11 +176,6 @@
 };
 #endif
 
-/* Solaris does not have floorf, but floor works. Should probably be in configure */
-#if defined(__sun) || defined(__sun__)
-static inline float floorf (float x) { return floor(x); }
-#endif
-
 enum {
 	STATE_OK,
 	STATE_WARNING,
diff -uNr nagios-plugins-1.4.11/plugins/Makefile.am nagios-plugins-1.4.12/plugins/Makefile.am
--- nagios-plugins-1.4.11/plugins/Makefile.am	2007-12-12 02:27:48.000000000 +0100
+++ nagios-plugins-1.4.12/plugins/Makefile.am	2008-03-14 16:44:27.000000000 +0100
@@ -4,10 +4,11 @@
 
 INCLUDES = -I.. -I$(top_srcdir)/lib -I$(top_srcdir)/gl -I$(top_srcdir)/intl @LDAPINCLUDE@ @PGINCLUDE@ @SSLINCLUDE@
 
-datadir = @datadir@
 localedir = $(datadir)/locale
+# gettext docs say to use AM_CPPFLAGS, but per module_CPPFLAGS override this
 DEFS = -DLOCALEDIR=\"$(localedir)\" @DEFS@
-LIBS = @LIBINTL@ @LIBS@
+# gettext docs say to use LDADD, but per module_LDADD override
+LIBS = @LTLIBINTL@ @LIBS@
 MATHLIBS = @MATHLIBS@
 
 # This is not portable. Run ". tools/devmode" to get development compile flags
diff -uNr nagios-plugins-1.4.11/plugins/negate.c nagios-plugins-1.4.12/plugins/negate.c
--- nagios-plugins-1.4.11/plugins/negate.c	2007-12-10 08:52:00.000000000 +0100
+++ nagios-plugins-1.4.12/plugins/negate.c	2008-05-02 11:28:15.000000000 +0200
@@ -1,79 +1,43 @@
-/******************************************************************************
-*
+/*****************************************************************************
+* 
 * Nagios negate plugin
-*
+* 
 * License: GPL
-* Copyright (c) 2002-2007 nagios-plugins team
-*
-* Last Modified: $Date: 2007-12-10 07:52:00 +0000 (Mon, 10 Dec 2007) $
-*
+* Copyright (c) 2002-2008 Nagios Plugins Development Team
+* 
+* Last Modified: $Date: 2008-05-02 10:28:15 +0100 (Fri, 02 May 2008) $
+* 
 * Description:
-*
+* 
 * This file contains the negate plugin
-*
-*  Negates the status of a plugin (returns OK for CRITICAL, and vice-versa)
-*
-* License Information:
-*
-* This program is free software; you can redistribute it and/or modify
+* 
+* Negates the status of a plugin (returns OK for CRITICAL, and vice-versa).
+* Can also perform custom state switching.
+* 
+* 
+* This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
-* the Free Software Foundation; either version 2 of the License, or
+* the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
-*
+* 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
-*
+* 
 * You should have received a copy of the GNU General Public License
-* along with this program; if not, write to the Free Software
-* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-*
-* $Id: negate.c 1859 2007-12-10 07:52:00Z dermoth $
-
-@@-<article>
-
-<sect1>
-<title>Quick Reference</title>
-<refentry>
-<refmeta><manvolnum>5<manvolnum></refmeta>
-<refnamdiv>
-<refname>&progname;</refname>
-<refpurpose>&SUMMARY;</refpurpose>
-</refnamdiv>
-</refentry>
-</sect1>
-
-<sect1>
-<title>FAQ</title>
-</sect1>
-
-<sect1>
-<title>Theory, Installation, and Operation</title>
-
-<sect2>
-<title>General Description</title>
-<para>
-&DESCRIPTION;
-</para>
-</sect2>
-
-<sect2>
-<title>Future Enhancements</title>
-<para>ToDo List</para>
-<itemizedlist>
-<listitem>Add option to do regex substitution in output text</listitem>
-</itemizedlist>
-</sect2>-@@
-
-******************************************************************************/
+* along with this program.  If not, see <http://www.gnu.org/licenses/>.
+* 
+* $Id: negate.c 1989 2008-05-02 09:28:15Z dermoth $
+* 
+*****************************************************************************/
 
 const char *progname = "negate";
-const char *revision = "$Revision: 1859 $";
-const char *copyright = "2002-2007";
+const char *revision = "$Revision: 1989 $";
+const char *copyright = "2002-2008";
 const char *email = "nagiosplug-devel@lists.sourceforge.net";
 
-#define DEFAULT_TIMEOUT 9
+#define DEFAULT_TIMEOUT 11
 
 #include "common.h"
 #include "utils.h"
@@ -85,6 +49,7 @@
 int validate_arguments (char **);
 void print_help (void);
 void print_usage (void);
+int subst_text = FALSE;
 
 static int state[4] = {
 	STATE_OK,
@@ -97,7 +62,7 @@
 main (int argc, char **argv)
 {
 	int found = 0, result = STATE_UNKNOWN;
-	char *buf;
+	char *buf, *sub;
 	char **command_line;
 	output chld_out, chld_err;
 	int i;
@@ -128,10 +93,22 @@
 		exit (STATE_WARNING);
 	}
 
+	/* Return UNKNOWN or worse if no output is returned */
 	if (chld_out.lines == 0)
-		die (STATE_UNKNOWN, _("No data returned from command\n"));
+		die (max_state_alt (result, STATE_UNKNOWN), _("No data returned from command\n"));
 
 	for (i = 0; i < chld_out.lines; i++) {
+		if (subst_text && result != state[result] &&
+		    result >= 0 && result <= 4) {
+			/* Loop over each match found */
+			while ((sub = strstr (chld_out.line[i], state_text (result)))) {
+				/* Terminate the first part and skip over the string we'll substitute */
+				*sub = '\0';
+				sub += strlen (state_text (result));
+				/* then put everything back together */
+				asprintf (&chld_out.line[i], "%s%s%s", chld_out.line[i], state_text (state[result]), sub);
+			}
+		}
 		printf ("%s\n", chld_out.line[i]);
 	}
 
@@ -142,25 +119,6 @@
 	}
 }
 
-/******************************************************************************
-@@-
-<sect2>
-<title>Functions</title>
-
-<sect3>
-<title>process_arguments</title>
-
-<para>This function parses the command line into the needed
-variables.</para>
-
-<para>Aside from the standard 'help' and 'version' options, there
-is a only a 'timeout' option.</para>
-
-</sect3>
--@@
-******************************************************************************/
-
-
 
 /* process command-line arguments */
 static const char **
@@ -178,11 +136,12 @@
 		{"warning", required_argument, 0, 'w'},
 		{"critical", required_argument, 0, 'c'},
 		{"unknown", required_argument, 0, 'u'},
+		{"substitute", no_argument, 0, 's'},
 		{0, 0, 0, 0}
 	};
 
 	while (1) {
-		c = getopt_long (argc, argv, "+hVt:o:w:c:u:", longopts, &option);
+		c = getopt_long (argc, argv, "+hVt:o:w:c:u:s", longopts, &option);
 
 		if (c == -1 || c == EOF)
 			break;
@@ -225,6 +184,9 @@
 				usage4 (_("Unknown must be a valid state name (OK, WARNING, CRITICAL, UNKNOWN) or integer (0-3)."));
 			permute = FALSE;
 			break;
+		case 's':     /* Substitute status text */
+			subst_text = TRUE;
+			break;
 		}
 	}
 
@@ -239,19 +201,6 @@
 }
 
 
-/******************************************************************************
-@@-
-<sect3>
-<title>validate_arguments</title>
-
-<para>No validation is currently done.</para>
-
-</sect3>
--@@
-******************************************************************************/
-
-
-
 int
 validate_arguments (char **command_line)
 {
@@ -262,13 +211,6 @@
 		usage4 (_("Require path to command"));
 }
 
-/******************************************************************************
-@@-
-</sect2> 
-</sect1>
-</article>
--@@
-******************************************************************************/
 
 int
 translate_state (char *state_text)
@@ -307,13 +249,15 @@
 	printf (_(UT_TIMEOUT), DEFAULT_TIMEOUT);
 	printf ("    %s\n", _("Keep timeout longer than the plugin timeout to retain CRITICAL status."));
 
-	printf(" -o,--ok=STATUS\n");
-	printf(" -w,--warning=STATUS\n");
-	printf(" -c,--critical=STATUS\n");
-	printf(" -u,--unknown=STATUS\n");
+	printf(" -o, --ok=STATUS\n");
+	printf(" -w, --warning=STATUS\n");
+	printf(" -c, --critical=STATUS\n");
+	printf(" -u, --unknown=STATUS\n");
 	printf(_("    STATUS can be 'OK', 'WARNING', 'CRITICAL' or 'UNKNOWN' without single\n"));
 	printf(_("    quotes. Numeric values are accepted. If nothing is specified, permutes\n"));
 	printf(_("    OK and CRITICAL.\n"));
+	printf(" -s, --substitute\n");
+	printf(_("    Substitute output text as well. Will only substitute text in CAPITALS\n"));
 
 	printf ("\n");
 	printf ("%s\n", _("Examples:"));
@@ -323,11 +267,11 @@
 	printf ("    %s\n", _("This will return OK instead of WARNING and UNKNOWN instead of CRITICAL"));
 	printf ("\n");
 	printf ("%s\n", _("Notes:"));
-	printf ("%s\n", _("This plugin is a wrapper to take the output of another plugin and invert it."));
-	printf ("%s\n", _("The full path of the plugin must be provided."));
-	printf ("%s\n", _("If the wrapped plugin returns OK, the wrapper will return CRITICAL."));
-	printf ("%s\n", _("If the wrapped plugin returns CRITICAL, the wrapper will return OK."));
-	printf ("%s\n", _("Otherwise, the output state of the wrapped plugin is unchanged."));
+	printf (" %s\n", _("This plugin is a wrapper to take the output of another plugin and invert it."));
+	printf (" %s\n", _("The full path of the plugin must be provided."));
+	printf (" %s\n", _("If the wrapped plugin returns OK, the wrapper will return CRITICAL."));
+	printf (" %s\n", _("If the wrapped plugin returns CRITICAL, the wrapper will return OK."));
+	printf (" %s\n", _("Otherwise, the output state of the wrapped plugin is unchanged."));
 
 	printf (_(UT_SUPPORT));
 }
@@ -338,5 +282,5 @@
 print_usage (void)
 {
 	printf (_("Usage:"));
-	printf ("%s [-t timeout] [-owcu STATE] <definition of wrapped plugin>\n", progname);
+	printf ("%s [-t timeout] [-owcu STATE] [-s] <definition of wrapped plugin>\n", progname);
 }
diff -uNr nagios-plugins-1.4.11/plugins/netutils.c nagios-plugins-1.4.12/plugins/netutils.c
--- nagios-plugins-1.4.11/plugins/netutils.c	2007-09-24 02:30:14.000000000 +0200
+++ nagios-plugins-1.4.12/plugins/netutils.c	2008-01-31 12:27:22.000000000 +0100
@@ -1,35 +1,34 @@
-/****************************************************************************
-*
+/*****************************************************************************
+* 
 * Nagios plugins network utilities
-*
+* 
 * License: GPL
 * Copyright (c) 1999 Ethan Galstad (nagios@nagios.org)
-*
-* Last Modified: $Date: 2007-09-24 01:30:14 +0100 (Mon, 24 Sep 2007) $
-*
+* Copyright (c) 2003-2008 Nagios Plugins Development Team
+* 
+* Last Modified: $Date: 2008-01-31 11:27:22 +0000 (Thu, 31 Jan 2008) $
+* 
 * Description:
-*
+* 
 * This file contains commons functions used in many of the plugins.
-*
-* License Information:
-*
-* This program is free software; you can redistribute it and/or modify
+* 
+* 
+* This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
-* the Free Software Foundation; either version 2 of the License, or
+* the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
-*
+* 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
-*
+* 
 * You should have received a copy of the GNU General Public License
-* along with this program; if not, write to the Free Software
-* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-*
-* $Id: netutils.c 1794 2007-09-24 00:30:14Z hweiss $
-*
-****************************************************************************/
+* along with this program.  If not, see <http://www.gnu.org/licenses/>.
+* 
+* $Id: netutils.c 1918 2008-01-31 11:27:22Z dermoth $
+* 
+*****************************************************************************/
 
 #define LOCAL_TIMEOUT_ALARM_HANDLER
 
@@ -168,7 +167,8 @@
 	struct addrinfo hints;
 	struct addrinfo *r, *res;
 	struct sockaddr_un su;
-	char port_str[6];
+	char port_str[6], host[MAX_HOST_ADDRESS_LENGTH];
+	size_t len;
 	int socktype, result;
 
 	socktype = (proto == IPPROTO_UDP) ? SOCK_DGRAM : SOCK_STREAM;
@@ -180,8 +180,18 @@
 		hints.ai_protocol = proto;
 		hints.ai_socktype = socktype;
 
+		len = strlen (host_name);
+		/* check for an [IPv6] address (and strip the brackets) */
+		if (len >= 2 && host_name[0] == '[' && host_name[len - 1] == ']') {
+			host_name++;
+			len -= 2;
+		}
+		if (len >= sizeof(host))
+			return STATE_UNKNOWN;
+		memcpy (host, host_name, len);
+		host[len] = '\0';
 		snprintf (port_str, sizeof (port_str), "%d", port);
-		result = getaddrinfo (host_name, port_str, &hints, &res);
+		result = getaddrinfo (host, port_str, &hints, &res);
 
 		if (result != 0) {
 			printf ("%s\n", gai_strerror (result));
diff -uNr nagios-plugins-1.4.11/plugins/netutils.h nagios-plugins-1.4.12/plugins/netutils.h
--- nagios-plugins-1.4.11/plugins/netutils.h	2007-01-24 23:47:25.000000000 +0100
+++ nagios-plugins-1.4.12/plugins/netutils.h	2008-01-31 12:45:28.000000000 +0100
@@ -1,36 +1,35 @@
-/******************************************************************************
-*
+/*****************************************************************************
+* 
 * Nagios plugins net utilities include file
-*
+* 
 * License: GPL
 * Copyright (c) 1999 Ethan Galstad (nagios@nagios.org)
-*
-* Last Modified: $Date: 2007-01-24 22:47:25 +0000 (Wed, 24 Jan 2007) $
-*
+* Copyright (c) 2003-2007 Nagios Plugins Development Team
+* 
+* Last Modified: $Date: 2008-01-31 11:45:28 +0000 (Thu, 31 Jan 2008) $
+* 
 * Description:
-*
+* 
 * This file contains common include files and function definitions
 * used in many of the plugins.
-*
-* License Information:
-*
-* This program is free software; you can redistribute it and/or modify
+* 
+* 
+* This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
-* the Free Software Foundation; either version 2 of the License, or
+* the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
-*
+* 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
-*
+* 
 * You should have received a copy of the GNU General Public License
-* along with this program; if not, write to the Free Software
-* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-*
-* $Id: netutils.h 1580 2007-01-24 22:47:25Z tonvoon $
-*
-******************************************************************************/
+* along with this program.  If not, see <http://www.gnu.org/licenses/>.
+* 
+* $Id: netutils.h 1919 2008-01-31 11:45:28Z dermoth $
+* 
+*****************************************************************************/
 
 #ifndef _NETUTILS_H_
 #define _NETUTILS_H_
diff -uNr nagios-plugins-1.4.11/plugins/popen.c nagios-plugins-1.4.12/plugins/popen.c
--- nagios-plugins-1.4.11/plugins/popen.c	2007-06-12 09:13:02.000000000 +0200
+++ nagios-plugins-1.4.12/plugins/popen.c	2008-01-31 12:27:22.000000000 +0100
@@ -1,48 +1,45 @@
-/****************************************************************************
- *
- * Nagios plugins popen
- *
- * License: GPL
- * Copyright (c) 2005 nagios-plugins team
- *
- * Last Modified: $Date: 2007-06-12 08:13:02 +0100 (Tue, 12 Jun 2007) $
- *
- * Description:
- *
- * A safe alternative to popen
- * 
- * Provides spopen and spclose
- *
- * FILE * spopen(const char *);
- * int spclose(FILE *);
- *
- *
- * Code taken with liitle modification from "Advanced Programming for the Unix
- * Environment" by W. Richard Stevens
- *
- * This is considered safe in that no shell is spawned, and the environment and
- * path passed to the exec'd program are esstially empty. (popen create a shell
- * and passes the environment to it).
- *
- * License Information:
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
- *
- * $Id: popen.c 1737 2007-06-12 07:13:02Z psychotrahe $
- *
- ******************************************************************************/
+/*****************************************************************************
+* 
+* Nagios plugins popen
+* 
+* License: GPL
+* Copyright (c) 2005-2007 Nagios Plugins Development Team
+* 
+* Last Modified: $Date: 2008-01-31 11:27:22 +0000 (Thu, 31 Jan 2008) $
+* 
+* Description:
+* 
+* A safe alternative to popen
+* 
+* Provides spopen and spclose
+* 
+* FILE * spopen(const char *);
+* int spclose(FILE *);
+* 
+* Code taken with liitle modification from "Advanced Programming for the Unix
+* Environment" by W. Richard Stevens
+* 
+* This is considered safe in that no shell is spawned, and the environment
+* and path passed to the exec'd program are essentially empty. (popen create
+* a shell and passes the environment to it).
+* 
+* 
+* This program is free software: you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation, either version 3 of the License, or
+* (at your option) any later version.
+* 
+* This program is distributed in the hope that it will be useful,
+* but WITHOUT ANY WARRANTY; without even the implied warranty of
+* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+* GNU General Public License for more details.
+* 
+* You should have received a copy of the GNU General Public License
+* along with this program.  If not, see <http://www.gnu.org/licenses/>.
+* 
+* $Id: popen.c 1918 2008-01-31 11:27:22Z dermoth $
+* 
+*****************************************************************************/
 
 #include "common.h"
 
diff -uNr nagios-plugins-1.4.11/plugins/popen.h nagios-plugins-1.4.12/plugins/popen.h
--- nagios-plugins-1.4.11/plugins/popen.h	2005-05-01 22:12:03.000000000 +0200
+++ nagios-plugins-1.4.12/plugins/popen.h	2008-01-31 12:45:28.000000000 +0100
@@ -1,8 +1,8 @@
 /******************************************************************************
- *
- * $Id: popen.h 1169 2005-05-01 20:12:03Z seanius $
- *
- ******************************************************************************/
+*
+* $Id: popen.h 1919 2008-01-31 11:45:28Z dermoth $
+*
+*****************************************************************************/
 
 FILE *spopen (const char *);
 int spclose (FILE *);
